package uk.ac.derby.lpt.sili2.machine;

public abstract class RepresentationAbstract implements Representation {
	
	/** Convert this to a primitive boolean. */
	public boolean booleanValue() {
		throw new ExceptionFatal("Cannot convert to boolean.");
	}
	
	/** Convert this to a primitive long. */
	public long longValue() {
		throw new ExceptionFatal("Cannot convert to integer.");
	}
	
	/** Convert this to a primitive double. */
	public double floatValue() {
		throw new ExceptionFatal("Cannot convert to rational.");
	}
	
	/** Convert this to a primitive string. */
	public String stringValue() {
		throw new ExceptionFatal("Cannot convert to string.");
	}
	
	public Representation concatenate(Representation v) {
		return new RepresentationString(stringValue() + v.stringValue());
	}
	
	public int compare(Representation v) {
		throw new ExceptionFatal("Cannot compare these operands.");
	}
	
	public Representation or(Representation v) {
		throw new ExceptionFatal("Cannot perform OR on these operands.");	
	}
	
	public Representation and(Representation v) {
		throw new ExceptionFatal("Cannot perform AND on these operands.");
	}

	public Representation not() {
		throw new ExceptionFatal("Cannot perform NOT on this operand.");		
	}
	
	public Representation add(Representation v) {
		throw new ExceptionFatal("Cannot perform + on these operands.");
	}

	public Representation subtract(Representation v) {
		throw new ExceptionFatal("Cannot perform - on these operands.");
	}

	public Representation mult(Representation v) {
		throw new ExceptionFatal("Cannot perform * on these operands.");
	}

	public Representation div(Representation v) {
		throw new ExceptionFatal("Cannot perform / on these operands.");
	}

	public Representation unary_plus() {
		throw new ExceptionFatal("Cannot perform + on this operand.");
	}

	public Representation unary_minus() {
		throw new ExceptionFatal("Cannot perform - on this operand.");
	}

	public void write() {
		System.out.println(stringValue());
	}
	
}
