package uk.ac.derby.lpt.sili2.machine;

public class RepresentationBoolean extends RepresentationAbstract {

	private boolean representation;
	
	public RepresentationBoolean(boolean b) {
		representation = b;
	}
	
	/** Convert this to a primitive boolean. */
	public boolean booleanValue() {
		return representation;
	}
	
	/** Convert this to a primitive string. */
	public String stringValue() {
		return (representation) ? "true" : "false";
	}
	
	public Representation or(Representation v) {
		return new RepresentationBoolean(representation || v.booleanValue());
	}

	public Representation and(Representation v) {
		return new RepresentationBoolean(representation && v.booleanValue());
	}

	public Representation not() {
		return new RepresentationBoolean(!representation);
	}

	public int compare(Representation v) {
		if (representation == v.booleanValue())
			return 0;
		else if (representation)
			return 1;
		else
			return -1;
	}
	
	public String toString() {
		return "" + representation;
	}
}
