package uk.ac.derby.lpt.sili2.machine;

public class RepresentationFloat extends RepresentationAbstract {

	private double representation;
	
	public RepresentationFloat(double b) {
		representation = b;
	}
	
	/** Convert this to a primitive double. */
	public double floatValue() {
		return (double)representation;
	}
	
	/** Convert this to a primitive String. */
	public String stringValue() {
		return "" + representation;
	}

	public int compare(Representation v) {
		if (representation == v.floatValue())
			return 0;
		else if (representation > v.floatValue())
			return 1;
		else
			return -1;
	}
	
	public Representation add(Representation v) {
		return new RepresentationFloat(representation + v.floatValue());
	}

	public Representation subtract(Representation v) {
		return new RepresentationFloat(representation - v.floatValue());
	}

	public Representation mult(Representation v) {
		return new RepresentationFloat(representation * v.floatValue());
	}

	public Representation div(Representation v) {
		return new RepresentationFloat(representation / v.floatValue());
	}

	public Representation unary_plus() {
		return new RepresentationFloat(representation);
	}

	public Representation unary_minus() {
		return new RepresentationFloat(-representation);
	}
	
	public String toString() {
		return "" + representation;
	}
}
