package uk.ac.derby.lpt.sili2.machine;

public class RepresentationInteger extends RepresentationAbstract {

	private long representation;
	
	public RepresentationInteger(long b) {
		representation = b;
	}
	
	/** Convert this to a primitive long. */
	public long longValue() {
		return representation;
	}
	
	/** Convert this to a primitive double. */
	public double floatValue() {
		return (double)representation;
	}
	
	/** Convert this to a primitive String. */
	public String stringValue() {
		return "" + representation;
	}

	public int compare(Representation v) {
		if (representation == v.longValue())
			return 0;
		else if (representation > v.longValue())
			return 1;
		else
			return -1;
	}
	
	public Representation add(Representation v) {
		return new RepresentationInteger(representation + v.longValue());
	}

	public Representation subtract(Representation v) {
		return new RepresentationInteger(representation - v.longValue());
	}

	public Representation mult(Representation v) {
		return new RepresentationInteger(representation * v.longValue());
	}

	public Representation div(Representation v) {
		return new RepresentationInteger(representation / v.longValue());
	}

	public Representation unary_plus() {
		return new RepresentationInteger(representation);
	}

	public Representation unary_minus() {
		return new RepresentationInteger(-representation);
	}
	
	public String toString() {
		return "" + representation;
	}
}
