package uk.ac.derby.lpt.sili2.machine;

public class RepresentationString extends RepresentationAbstract {

	private String internalValue;
	
	/** Return a ValueString given a quote-delimited source string. */
	public static RepresentationString stripDelimited(String b) {
		return new RepresentationString(b.substring(1, b.length() - 1));
	}
	
	public RepresentationString(String b) {
		internalValue = b;
	}
	
	/** Convert this to a String. */
	public String stringValue() {
		return internalValue;		
	}

	public int compare(Representation v) {
		return internalValue.compareTo(v.stringValue());
	}
	
	/** Add performs string concatenation. */
	public Representation add(Representation v) {
		return new RepresentationString(internalValue + v.stringValue());
	}
	
	public String toString() {
		return internalValue;
	}
}
