package uk.ac.derby.lpt.sili2.types;

import uk.ac.derby.lpt.sili2.interpreter.Value;

/** An abstract Type, that defines all possible operations on this type, and values of this type. */
public interface Type {
	
	/** Get name of this type. */
	public String getName();

	public Value or(Value v1, Value v2);

	public Value and(Value v1, Value v2);

	public Value not(Value v);

	public Value add(Value v1, Value v2);

	public Value subtract(Value v1, Value v2);

	public Value mult(Value v1, Value v2);

	public Value div(Value v1, Value v2);

	public Value unary_plus(Value v);

	public Value unary_minus(Value v);

	public int compare(Value v1, Value v2);

	/** Test this value and another for equality. */
	public Value eq(Value v1, Value v2);
	
	/** Test this value and another for non-equality. */
	public Value neq(Value v1, Value v2);
	
	/** Test this value and another for >= */
	public Value gte(Value v1, Value v2);
	
	/** Test this value and another for <= */
	public Value lte(Value v1, Value v2);
	
	/** Test this value and another for > */
	public Value gt(Value v1, Value v2);
	
	/** Test this value and another for < */	
	public Value lt(Value v1, Value v2);

	public boolean isTrue(Value value);

	public void write(Value value);
	
}
