package uk.ac.derby.lpt.sili2.types;

import uk.ac.derby.lpt.sili2.interpreter.Value;
import uk.ac.derby.lpt.sili2.machine.RepresentationBoolean;

public class TypeBoolean extends TypeAbstract {

	static Type thisInstance = new TypeBoolean();
	
	static Value trueValue = new Value(thisInstance, new RepresentationBoolean(true));
	static Value falseValue = new Value(thisInstance, new RepresentationBoolean(false));

	public static Value getTrue() {
		return trueValue;
	}
	
	public static Value getFalse() {
		return falseValue;
	}
	
	public static Value getBoolean(boolean b) {
		return (b) ? trueValue : falseValue;
	}
	
	protected TypeBoolean() {
	}
	
	public static Type getInstance() {
		return thisInstance;
	}

	@Override
	public String getName() {
		return "boolean";
	}
	
	public Value or(Value v1, Value v2) {
		return getBoolean(v1.getRepresentation().or(v2.getRepresentation()).booleanValue());
	}

	public Value and(Value v1, Value v2) {
		return getBoolean(v1.getRepresentation().and(v2.getRepresentation()).booleanValue());
	}

	public Value not(Value v) {
		return getBoolean(v.getRepresentation().booleanValue());
	}

}
