package uk.ac.derby.lpt.sili2.types;

import uk.ac.derby.lpt.sili2.interpreter.ExceptionSemantic;
import uk.ac.derby.lpt.sili2.interpreter.Value;

public abstract class TypeNumeric extends TypeAbstract {

	protected abstract Type getInstanceMember();
	
	public Value add(Value v1, Value v2) {
		if (v2.getType().getName() != getName())
			throw new ExceptionSemantic("Cannot perform + on " + v1.getType().getName() + " and " + v2.getType().getName());
		return new Value(getInstanceMember(), v1.getRepresentation().add(v2.getRepresentation()));
	}

	public Value subtract(Value v1, Value v2) {
		if (v2.getType().getName() != getName())
			throw new ExceptionSemantic("Cannot perform - on " + v1.getType().getName() + " and " + v2.getType().getName());
		return new Value(getInstanceMember(), v1.getRepresentation().subtract(v2.getRepresentation()));
	}

	public Value mult(Value v1, Value v2) {
		if (v2.getType().getName() != getName())
			throw new ExceptionSemantic("Cannot perform * on " + v1.getType().getName() + " and " + v2.getType().getName());
		return new Value(getInstanceMember(), v1.getRepresentation().mult(v2.getRepresentation()));
	}

	public Value div(Value v1, Value v2) {
		if (v2.getType().getName() != getName())
			throw new ExceptionSemantic("Cannot perform / on " + v1.getType().getName() + " and " + v2.getType().getName());
		return new Value(getInstanceMember(), v1.getRepresentation().div(v2.getRepresentation()));
	}

	public Value unary_plus(Value v) {
		return new Value(getInstanceMember(), v.getRepresentation().unary_plus());
	}

	public Value unary_minus(Value v) {
		return new Value(getInstanceMember(), v.getRepresentation().unary_minus());
	}

}
